package nc.ui.bd.ref;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.Vector;

import nc.bs.logging.Logger;
import nc.bs.uif2.BusinessExceptionAdapter;
import nc.ui.dbcache.DBCacheFacade;
import nc.ui.pub.beans.UIRefPane;
import nc.vo.dbcache.MatchPkVO;
import nc.vo.pub.BusinessException;

/**
 * ˴˵ ڣ(2003-6-25 15:47:46)
 * 
 * @authorѧ
 */
public class BatchMatchContext implements java.io.Serializable {
	/**
	 * <code>serialVersionUID</code> ע
	 */
	private static final long serialVersionUID = 1L;

	public java.util.Hashtable htUIRePaneTable = new java.util.Hashtable();

	public java.util.Hashtable htPK = new java.util.Hashtable();

	/** ǼִеSQL */
	public java.util.Hashtable htSql = new java.util.Hashtable();

	public java.util.Hashtable htSqlCache = new java.util.Hashtable();

	public boolean m_beInBatchMatch = false;

	private int nCount = 0;

	private static BatchMatchContext bmc = new BatchMatchContext();

	private BatchMatchContext() {
	}

	public void addMatchData(UIRefPane urf, Object pkValue) {
		int nLoc = nCount++;
		htUIRePaneTable.put(Integer.valueOf(nLoc), urf);
		htPK.put(Integer.valueOf(nLoc), pkValue);
	}

	/**
	 * ˴뷽˵ ڣ(2003-6-25 15:56:22)
	 */
	public void clear() {
		htPK.clear();
		htUIRePaneTable.clear();
		nCount = 0;
	}

	/**
	 * ȡݣע⼸ĲգҪ⴦ 1Ҫ洦Ĳ "", "ļ", "ɫ", "", "ı"
	 * 2Ҫ⴦ݣ "˾Ŀ¼()", "˾Ŀ¼()S", "Ȩ޹˾Ŀ¼()" 3ʱȡ ƿĿ汾
	 * 
	 */
	public void executeBatch() {
		UIRefPane ref = null;
		Object pkValue = null;
		String matchSql = null;

		List<String> listSql = new ArrayList<String>();
		List<UIRefPane> listRef = new ArrayList<UIRefPane>();
		// ݲ
		List<String> listBigDataSql = new ArrayList<String>();
		List<UIRefPane> listBigDataRef = new ArrayList<UIRefPane>();
		List<String[]> listBigDataPkvalue = new ArrayList<String[]>();

		String dataSourceName = null;
		for (int i = 0; i < nCount; i++) {

			ref = (UIRefPane) htUIRePaneTable.get(Integer.valueOf(i));

			AbstractRefModel model = ref.getRefModel();

			pkValue = htPK.get(Integer.valueOf(i));

			// Ҫ洦Ĳ "", "ļ", "ɫ", "", "ı"
			if (!ref.isBatchData()) {
				ref.setPK(pkValue);
				continue;
			}
			// Ҫ㣻
			if (model == null || pkValue == null) {
				continue;
			}

			dataSourceName = model.getDataSource();

			String[] strPKValues = null;

			if (pkValue instanceof String[]) {

				strPKValues = (String[]) pkValue;

			} else if (pkValue.toString().contains(",")) {
				strPKValues = pkValue.toString().split(",");
			}else {
				strPKValues = new String[] { pkValue.toString() };
			}

			matchSql = model.getMatchSql(strPKValues);

			Logger.debug("executeBatch sql: " + matchSql);

			// յĴ "˾Ŀ¼()", "˾Ŀ¼()S", "Ȩ޹˾Ŀ¼()"
			// ƿĿ汾
			// า matchPkData(String strPkValue)  matchPkData(String[]
			// strPkValues)Ҳȡ
			// ԶԷ,Ҳȡ
			// LRUѾƥ 5.6 ¼

			if (model instanceof AbstractRefGridTreeBigDataModel
					&& model.getMatchVectorFromLRU(strPKValues) == null) {

				listBigDataSql.add(matchSql);
				listBigDataRef.add(ref);
				listBigDataPkvalue.add(strPKValues);

				continue;
			}

			if (model.isNonSqlMatch(matchSql) || model.isFromTempTable()
					|| isMatchPKDataOverridden(model) || isAutoMultiLang(model)
					|| model.getMatchVectorFromLRU(strPKValues) != null) {

				ref.setPKs(strPKValues);

				continue;
			}

			listRef.add(ref);

			listSql.add(matchSql);

		}

		dispatchDataToRef(listSql, listRef, dataSourceName);
		dispatchDataToBigdataRef(listBigDataSql, listBigDataRef,
				listBigDataPkvalue);

	}

	private void dispatchDataToRef(List<String> listSql,
			List<UIRefPane> listRef, String dsName) {
		UIRefPane ref;
		Vector[] vr = null;

		if (listSql.size() > 0) {
			String[] sqls = filterSameSqls(listSql);

			try {

				vr = RefBO_Client.queryMainBatch(dsName, sqls);
				HashMap<String, Vector> hm = sql2Vec(sqls, vr);

				for (int i = 0; i < listSql.size(); i++) {
					ref = listRef.get(i);
//					ref.getRefModel().setSelectedDataAndConvertData(vr[i]);
					ref.getRefModel().setSelectedDataAndConvertData(
							hm.get(listSql.get(i)));
					ref.getRefModel().fireChange();

				}

			} catch (Exception e) {
				Logger.error(e.getMessage());
				throw new BusinessExceptionAdapter(new BusinessException(e));
			}

		}
	}

	private String[] filterSameSqls(List<String> listSql) {

		Set<String> set = new HashSet<String>();
		set.addAll(listSql);
		return set.toArray(new String[0]);

	}

	private HashMap sql2Vec(String[] sqls, Vector[] vec) {
		HashMap<String, Vector> hm = new HashMap<String, Vector>();
		for (int i = 0; i < sqls.length; i++) {
			hm.put(sqls[i], vec[i]);
		}
		return hm;
	}

	private void dispatchDataToBigdataRef(List<String> listBigDataSql,
			List<UIRefPane> listBigDataRef, List<String[]> listBigDataPkvalue) {

		if (listBigDataSql.size() == 0) {
			return;
		}

		Vector[] vr = null;
		UIRefPane ref = null;
		List<MatchPkVO> matchPKVOList = new ArrayList<MatchPkVO>();
		for (int i = 0; i < listBigDataSql.size(); i++) {
			ref = listBigDataRef.get(i);
			AbstractRefModel model = ref.getRefModel();
			MatchPkVO matchPkVO = new MatchPkVO(listBigDataSql.get(i),
					listBigDataPkvalue.get(i), model.getPkFieldCode());
			matchPKVOList.add(matchPkVO);

		}

		try {

			vr = DBCacheFacade.batchMatchPK(matchPKVOList);
			for (int i = 0; i < listBigDataRef.size(); i++) {
				ref = listBigDataRef.get(i);
				ref.getRefModel().setSelectedDataAndConvertData(vr[i]);
				ref.getRefModel().fireChange();

			}

		} catch (Exception e) {
			Logger.error(e.getMessage());
			throw new BusinessExceptionAdapter(new BusinessException(e));
		}

	}

	/*
	 * жǷาmatchPkData(String strPkValue)matchPkData(String[] strPkValues)
	 * 
	 */
	private boolean isMatchPKDataOverridden(AbstractRefModel model) {
		boolean isOverridden = false;

		// жmatchPkData(String strPkValue)Ƿ񱻸
		try {
			Method matchPkData = model.getClass().getDeclaredMethod(
					"matchPkData", String.class);

			if (matchPkData != null) {
				isOverridden = true;
			}

		} catch (Exception e) {
			// TODO: handle exception
		}
		// жmatchPkData(String[] strPkValues)Ƿ񱻸
		try {

			Method matchPkData = model.getClass().getDeclaredMethod(
					"matchPkData", String[].class);
			if (matchPkData != null) {
				isOverridden = true;
			}

		} catch (Exception e) {
			// TODO: handle exception
		}

		return isOverridden;
	}

	/*
	 * ǷԶԷ롣
	 */
	private boolean isAutoMultiLang(AbstractRefModel model) {
		return model.getRefVO_mlang() != null;
	}

	public static BatchMatchContext getShareInstance() {
		return bmc;
	}

	/**
	 * ˴뷽˵ ڣ(2003-6-25 15:57:20)
	 * 
	 * @return boolean
	 */
	public boolean isInBatchMatch() {
		return m_beInBatchMatch;
	}

	/**
	 * ˴뷽˵ ڣ(2003-6-25 15:57:20)
	 * 
	 * @param newM_beInBatchMatch
	 *            boolean
	 */
	public void setInBatchMatch(boolean newM_beInBatchMatch) {
		m_beInBatchMatch = newM_beInBatchMatch;
		clear();
	}

}
